﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataBase
{
    public partial class Form1 : Form
    {
        DataTable DT = new DataTable("MainList");
        DataView DV = new DataView();

        public Form1()
        {
            InitializeComponent();
            dataGridView1.DataError += dataGridView1_DataError;
        }

        void dataGridView1_DataError(object sender, DataGridViewDataErrorEventArgs e)
        {
            MessageBox.Show("Колонка " +
                DT.Columns[e.ColumnIndex].Caption+", строка "+(e.RowIndex+1),
                "Ошибка в данных", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void CreateButton_Click(object sender, EventArgs e)
        {
            DataColumn DCFamily = new DataColumn("Family", Type.GetType("System.String"));
            DCFamily.AllowDBNull = false;
            DT.Columns.Add(DCFamily);

            DataColumn DCName = new DataColumn("Name", Type.GetType("System.String"));
            DT.Columns.Add(DCName);

            DataColumn DCYear = new DataColumn("Year", Type.GetType("System.Int32"));
            DCYear.DefaultValue = 2000;
            DT.Columns.Add(DCYear);

            DataBind();

        }

        private void DataBind()
        {
            dataGridView1.DataSource = DT;
            CreateButton.Enabled = false;

            DV.Table = DT;
            DV.RowFilter = "";
            dataGridView2.DataSource = DV;
            dataGridView2.ReadOnly = true;

            SaveButton.Enabled = true;
            checkBox1.Enabled = true;
        }

        private void SaveButton_Click(object sender, EventArgs e)
        {
            DT.WriteXml("Table.xml",XmlWriteMode.WriteSchema);
        }

        private void LoadButton_Click(object sender, EventArgs e)
        {
            try
            {
                DT.Clear();
                DT.ReadXml("Table.xml");
                DataBind();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка загрузки", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            label1.Text=
            DV.RowFilter = "Family like '" + textBox1.Text + "*'";
        }

        private void ExitButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            switch(MessageBox.Show("Сохранить", "Выход", 
                MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question))
            {
                case DialogResult.Yes:
                    SaveButton_Click(this, e);
                    break;
                case DialogResult.Cancel:
                    e.Cancel = true;
                    break;
            }
            base.OnClosing(e);
       }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timer1.Interval = 60000 * (int)numericUpDown1.Value;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked) timer1.Start();
            else timer1.Stop();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            SaveButton_Click(this, e);
        }
    }
}
